/*
 *  lol++.h
 *  
 *  LOL++, implementation of LOLCODE-like language on top of C++
 *  Copyright (C) 2008-2009 Yusdi Saliman
 *
 *  This file contains preprocessor macros required to enable LOLCODE-like
 *  syntax in LOL++.
 *  Current LOL++ implementation is based on LOLCODE specification version 1.2.
 *
 *  LOL++ is free software. It comes without any warranty, to
 *  the extent permitted by applicable law. You can redistribute it
 *  and/or modify it under the terms of the Do What The Fuck You Want
 *  To Public License, Version 2, as published by Sam Hocevar. See
 *  http://sam.zoy.org/wtfpl/COPYING for more details.
 */

#define HAI	int main() {
#define KTHXBYE	return 0; }

#define BTW(...)

//////// types
#include "lol_types.h"
#define NOOB    __LOL_NOOB
#define YARN    __LOL_YARN
#define NUMBR   __LOL_NUMBR
#define NUMBAR  __LOL_NUMBAR
#define TROOF   __LOL_TROOF
#define WIN true
#define FAIL    false

#define IT  __lol_it_var

// Unlike LOLCODE, simply returning a variable cannot set the value of IT.
// IT can be explicitly set using either:
//     IT R <expression>
// or:
//     ZOMG ITZ <expression>
#define ZOMG    __lol_it_var

//////// declaration and assignment
#define I   __LolData
#define HAS
#define A
#define ITZ	=
#define R	=

//////// operators
#include "lol_operator.h"

// all operations need to be terminated with MKAY or _
#define _	)
#define AN	,
#define OF	(
#define MKAY	)
#define SUM	__lol_sum
#define DIFF	__lol_diff
#define PRODUKT	__lol_produkt
#define QUOSHUNT	__lol_quoshunt
#define MOD	__lol_mod
#define BIGGR	__lol_biggr
#define SMALLR	__lol_smallr
#define BOTH	__lol_both
#define EITHER	__lol_either
#define WON	__lol_won
#define NOT	__lol_not(
#define ALL	__lol_all
#define ANY	__lol_any
#define SAEM	(true,true,false) && __lol_both_saem(
#define DIFFRINT	__lol_diffrint(
#define SMOOSH	__lol_smoosh(	// AN is mandatory to separate arguments!

// MAEK is different than official LOLCODE spec!
//
// MAEK <variable> TEH <type> MKAY
//
#define TEH	,
#define MAEK	__lol_maek(
#define IS  .castTo(
#define NOW

//////// input/output
#include "lol_io.h"

// Also end all I/O statements with MKAY or _
#define VISIBLE	__lol_visible((__LolData) 
#define XD  ,false  // An XD at the end of VISIBLE (before MKAY) means no new
                    // new line will be automatically added
#define GIMMEH	__lol_gimmeh(

//////// flow control
#include "lol_flowctrl.h"
#define O	if (__lol_orly())
#define RLY	// No question mark after O RLY
#define YA	{
#define NO	}
#define WAI	else {
#define OIC	}
#define MEBBE(x)	} else if ( (x).toBool() ) {

#define WTF switch (__lol_it().toInt()) {	// no question mark after WTF
#define OMG case
#define GTFO	break
#define OMGWTF	default

#define IM
#define IN	for (__lol_initLoop();
#define YR
#define LOOP	// the only label permitted is LOOP
#define UPPIN	__lol_uppin(
#define NERFIN	__lol_nerfin(
#define TIL(x)	) && __lol_not( x ).toBool(); ) {
#define WILE(x)	) && (x).toBool(); ) {
#define OUTTA	}

// special case (different than the official spec!)
// to create infinite loop, use the following syntax:
//
// IM IN YR LOOP FOREVAR
//     <code block>
// IM OUTTA YR LOOP
//
#define FOREVAR	;) {

//////// functions
// the prototype is different than the language spec:
//
// HOW DUZ I <function name> ([UR <argument1> [AN UR <argument2> ...]])
// LIEK DIZ
//     <code block>
// IF U SAY SO
//
// calling:
// <function name> ([<expression1> [AN <expression2> [AN <expression3> ...]]])

// AN, YR, and GTFO are already defined above
#define HOW
#define DUZ
#define UR	__LolData
#define LIEK
#define DIZ { __LolData __noob; bool __gtfo = true; do {
#define FOUND	return __lol_it_var = 
#define IF
#define U
#define SAY
#define SO	__gtfo = false; } while(0); \
            if (__gtfo) return __noob; else return __lol_it(); }

// reserved keywords
#define BUKKIT

#ifndef DONT_USE_EXTENSION

///////// LOL++ extension that provides functionality not found in LOLCODE 1.2

//// Array
//
// Array is automatically allocated when used, and is declared the same way
// as declaring ordinary variable. To access element in array, use brackets just
// like in C/C++. Index starts from 1.
//
// To get the allocated size, use:
//
//     <array name> LENGTH
//
// Example:
//
//     I HAS A array;
//     array[1] = 10;
//     array[3] = "test";
//     VISIBLE SMOOSH array[1] AN array[2] AN array[3] MKAY _;
//     VISIBLE array LENGTH _;
//
// The output is:
// 
//     10NOOBtest
//     3

#define LENGTH  .getLength()

#endif // DONT_USE_EXTENSION
