/*
 *  lol_io.h
 *  
 *  LOL++, implementation of LOLCODE-like language on top of C++
 *  Copyright (C) 2008-2009 Yusdi Saliman
 *
 *  This file contains the declaration of I/O functions.
 *
 *  LOL++ is free software. It comes without any warranty, to
 *  the extent permitted by applicable law. You can redistribute it
 *  and/or modify it under the terms of the Do What The Fuck You Want
 *  To Public License, Version 2, as published by Sam Hocevar. See
 *  http://sam.zoy.org/wtfpl/COPYING for more details.
 */

#ifndef LOL_IO_H
#define LOL_IO_H

#include "lol_types.h"

void __lol_visible(__LolData lol, bool addNewLine = true);

void __lol_gimmeh(__LolData& lol);

// Special characters in LOLCODE.
// :", :(<hex>), :{<var>}, and :[<char name>] are *not* supported.
#define __LOL_ESC_CHAR  ':'
#define __LOL_NEWLINE   ')'
#define __LOL_TAB   '>'
#define __LOL_COLON ':'
#define __LOL_BELL  'o'

#endif
