/*
 *  lol_operator.h
 *  
 *  LOL++, implementation of LOLCODE-like language on top of C++
 *  Copyright (C) 2008-2009 Yusdi Saliman
 *
 *  This file contains the declaration of LOL++ operator functions.
 *
 *  LOL++ is free software. It comes without any warranty, to
 *  the extent permitted by applicable law. You can redistribute it
 *  and/or modify it under the terms of the Do What The Fuck You Want
 *  To Public License, Version 2, as published by Sam Hocevar. See
 *  http://sam.zoy.org/wtfpl/COPYING for more details.
 */

#ifndef LOL_OPERATOR_H
#define LOL_OPERATOR_H

#include "lol_types.h"

__LolData __lol_sum(__LolData data1, __LolData data2);

__LolData __lol_diff(__LolData data1, __LolData data2);

__LolData __lol_produkt(__LolData data1, __LolData data2);

__LolData __lol_quoshunt(__LolData data1, __LolData data2);

__LolData __lol_mod(__LolData data1, __LolData data2);

__LolData __lol_biggr(__LolData data1, __LolData data2);

__LolData __lol_smallr(__LolData data1, __LolData data2);

__LolData __lol_both(__LolData data1, __LolData data2, bool changeIt = true);

__LolData __lol_either(__LolData data1, __LolData data2);

__LolData __lol_won(__LolData data1, __LolData data2);

__LolData __lol_not(__LolData data);

__LolData __lol_all(__LolData data1, __LolData data2,
                    __LolData data3 = true, __LolData data4 = true,
                    __LolData data5 = true, __LolData data6 = true,
                    __LolData data7 = true, __LolData data8 = true);

__LolData __lol_any(__LolData data1, __LolData data2,
                    __LolData data3 = false, __LolData data4 = false,
                    __LolData data5 = false, __LolData data6 = false,
                    __LolData data7 = false, __LolData data8 = false);

__LolData __lol_both_saem(__LolData data1, __LolData data2);

__LolData __lol_diffrint(__LolData data1, __LolData data2);

__LolData __lol_smoosh(__LolData data1, __LolData data2,
                       __LolData data3 = "", __LolData data4 = "",
                       __LolData data5 = "", __LolData data6 = "",
                       __LolData data7 = "", __LolData data8 = "");

__LolData __lol_maek(__LolData data, __LOL_TYPES type);

#endif
