/*
 *  lol_flowctrl_test.cpp
 *  
 *  LOL++, implementation of LOLCODE-like language on top of C++
 *  Copyright (C) 2008-2009 Yusdi Saliman
 *
 *  This file contains a simple unit test program to test flow control functions
 *
 *  LOL++ is free software. It comes without any warranty, to
 *  the extent permitted by applicable law. You can redistribute it
 *  and/or modify it under the terms of the Do What The Fuck You Want
 *  To Public License, Version 2, as published by Sam Hocevar. See
 *  http://sam.zoy.org/wtfpl/COPYING for more details.
 */

#include "lol_flowctrl.h"
#include "lol_operator.h"

#include <iostream>
#include <cassert>
using namespace std;

int main()
{
    // O RLY test
    __LolData lol = 2;
    __lol_both_saem(lol, 2);
    assert(__lol_orly());
    
    // UPPIN/NERFIN integer test
    __lol_uppin(lol);
    assert(lol == 3);
    __lol_nerfin(lol);
    assert(lol == 2);
    
    // UPPIN/NERFIN float test
    lol = 1.5;
    __lol_uppin(lol);
    assert(lol == 2.5);
    __lol_nerfin(lol);
    assert(lol == 1.5);
    
    cout << "All tests passed.\n";
    return 0;
}
